package cn.myapps.email.model;

import cn.myapps.auth.model.Domain;
import cn.myapps.common.auth.IUser;
import com.teemlink.email.email.action.EmailUserHelper;
import com.teemlink.email.email.model.EmailUser;
import com.teemlink.email.runtime.mail.ConnectionMetaHandler;

import javax.servlet.http.HttpServletRequest;

public class WebUser implements IUser {

    private String id;

    private String domainid;

    private String name;

    /**
     * 默认部门
     */
    private String defaultDepartment;

    private EmailUser emailUser;

    private Domain domain;

    public Domain getDomain() {
        return domain;
    }

    public void setDomain(Domain domain) {
        this.domain = domain;
    }

    // 邮件链接句柄
    private transient ConnectionMetaHandler connectionMetaHandler;

    public ConnectionMetaHandler getConnectionMetaHandler() throws Exception {
        return connectionMetaHandler;
    }

    /**
     * 获取邮件链接句柄
     *
     * @return the connectionMetaHandler
     * @author Tom
     */
    public ConnectionMetaHandler getConnectionMetaHandler(HttpServletRequest request) throws Exception {
        if (connectionMetaHandler == null) {
            EmailUserHelper.initConnectionHandler(this,request);
        }
        return connectionMetaHandler;
    }

    /**
     * 设置邮件链接句柄
     *
     * @param connectionMetaHandler the connectionMetaHandler to set
     * @author Tom
     */
    public void setConnectionMetaHandler(ConnectionMetaHandler connectionMetaHandler) {
        this.connectionMetaHandler = connectionMetaHandler;
    }

    public EmailUser getEmailUser() {
        return emailUser;
    }

    public void setEmailUser(EmailUser emailUser) {
        this.emailUser = emailUser;
    }

    @Override
    public String getId() {
        return this.id;
    }

    @Override
    public String getDomainid() {
        return this.domainid;
    }

    @Override
    public String getName() {
        return this.name;
    }

    @Override
    public String getDefaultDepartment() {
        return this.defaultDepartment;
    }

    @Override
    public boolean isDeveloper() {
        return false;
    }

    @Override
    public String getDefaultApplication() {
        return null;
    }

    @Override
    public boolean isDomainAdmin() {
        return false;
    }

    @Override
    public boolean isSuperAdmin() {
        return false;
    }

    @Override
    public String getAvatarUri() {
        return null;
    }

    @Override
    public String getTelephone() {
        return null;
    }

    @Override
    public String getLoginno() {
        return null;
    }

    @Override
    public IUser getSuperior() {
        return null;
    }

    @Override
    public int getStatus() {
        return 0;
    }

    @Override
    public String getProxyUserId() {
        return null;
    }

    @Override
    public String getSessionid() {
        return null;
    }

    @Override
    public boolean isAgent(String actorid, String flowid) throws Exception {
        return false;
    }

    @Override
    public int getEquipment() {
        return 0;
    }

    @Override
    public String getLowerDepartmentList() throws Exception {
        return null;
    }

    @Override
    public String getCalendarType() {
        return null;
    }

    @Override
    public String getIndexCode() {
        return null;
    }

    @Override
    public void setDomainid(String domainid) {
        this.domainid = domainid;
    }

    @Override
    public void setName(String name) {
        this.name = name;
    }

    @Override
    public String getEmail() {
        return null;
    }

    @Override
    public String getType() {
        return null;
    }

    @Override
    public String getDeptlist() throws Exception {
        return null;
    }

    @Override
    public String getRolelist() throws Exception {
        return null;
    }

    @Override
    public String getRolelist(String applicationid) throws Exception {
        return null;
    }

    @Override
    public void setId(String owner) {
        this.id = owner;
    }

    @Override
    public void setLoginpwd(String loginpwd) {

    }

    @Override
    public void setEmail(String email) {

    }

    @Override
    public void setSigns(String signs) {

    }

    @Override
    public void setTelephone(String telephone) {

    }

    @Override
    public String getLoginpwd() {
        return null;
    }

    @Override
    public String getSigns() {
        return null;
    }

    @Override
    public String getDdUserId() {
        return null;
    }

    @Override
    public boolean isRecordLog() {
        return false;
    }

    @Override
    public void setRecordLog(boolean recordLog) {

    }
    public void setDefaultDepartment(String defaultDepartment) {
        this.defaultDepartment = defaultDepartment;
    }
}
