package com.teemlink.email.runtime.mail;

import java.io.Serializable;

/**
 * 
 * @author Tom
 *
 */
public class ConnectionProfile implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 852751875398652497L;
	private String id;
	//邮件功能域
	private String shortName;
	//收取邮件服务器
	private String fetchServer;
	//收取服务器端口
	private String fetchPort;
	//收取邮件协议
	private String protocol;
	//发送邮件服务器
	private String smtpServer;
	//发送邮件端口
	private String smtpPort;
	//是否可附带附件
	private String smtpAuthenticated;
	private String folderNameSpace;
	//是否需要收取证书
	private String fetchSSL;
	//是否需要发送证书
	private String smtpSSL;
	//是否支持排序
	private boolean supportSort;

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	/**
	 * Default constructor
	 */
    public ConnectionProfile() {
        super();
    }

    /**
     * @return Returns the fetchPort.
     */
    public int getIFetchPort() {
        return Integer.parseInt(fetchPort);
    }

    /**
     * @return Returns the fetchServer.
     */
    public String getFetchServer() {
        return fetchServer;
    }
    /**
     * @param fetchServer The fetchServer to set.
     */
    public void setFetchServer(String fetchServer) {
        this.fetchServer = fetchServer;
    }
    /**
     * @return Returns the smtpPort.
     */
    public int getISmtpPort() {
        return Integer.parseInt(smtpPort);
    }

    /**
     * @return Returns the smtpServer.
     */
    public String getSmtpServer() {
        return smtpServer;
    }
    /**
     * @param smtpServer The smtpServer to set.
     */
    public void setSmtpServer(String smtpServer) {
        this.smtpServer = smtpServer;
    }
    /**
     * @return Returns the protocol.
     */
    public String getProtocol() {
        return protocol;
    }
    /**
     * @param protocol The protocol to set.
     */
    public void setProtocol(String protocol) {
        this.protocol = protocol;
    }
	/**
	 * @return
	 */
	public String getShortName() {
		return shortName;
	}

	/**
	 * @param string
	 */
	public void setShortName(String string) {
		shortName = string;
	}

	/**
	 * @return
	 */
	public String getFetchPort() {
		return fetchPort;
	}

	/**
	 * @return
	 */
	public String getSmtpPort() {
		return smtpPort;
	}

	/**
	 * @param string
	 */
	public void setFetchPort(String string) {
		fetchPort = string;
	}

	/**
	 * @param string
	 */
	public void setSmtpPort(String string) {
		smtpPort = string;
	}

	/**
	 * @return
	 */
	public String getSmtpAuthenticated() {
		return smtpAuthenticated;
	}

	/**
	 * @param string
	 */
	public void setSmtpAuthenticated(String string) {
		smtpAuthenticated = string;
	}

	public String getFolderNameSpace() {
		return folderNameSpace;
	}

	public void setFolderNameSpace(String folderNameSpace) {
		this.folderNameSpace = folderNameSpace;
	}

	public String getFetchSSL() {
		return fetchSSL;
	}

	public void setFetchSSL(String fetchSSL) {
		this.fetchSSL = fetchSSL;
	}

	public String getSmtpSSL() {
		return smtpSSL;
	}

	public void setSmtpSSL(String smtpSSL) {
		this.smtpSSL = smtpSSL;
	}

	public boolean isSupportSort() {
		return supportSort;
	}

	public void setSupportSort(boolean supportSort) {
		this.supportSort = supportSort;
	}

}
